#include "EsoAcsammm_Header.hpp"
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */
/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */
/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */
/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */
/* We do not support C11 <threads.h>.  */
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void a1_res(int bmode_1, double* yy, double* a1_yy, double* der_x, double* a1_der_x, double* x, double* a1_x, double* p, double* a1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c)
#pragma ad indep x a1_x p a1_p a1_yy
#pragma ad dep yy a1_x a1_p
{
   int i_E=0;
   int i_C=0;
   int i__=0;
   int j__=0;
   int k__=0;
   int m__=0;
   int r_i=0;
   int r_j=0;
   int i_a=0;
   int i_b=0;
   int i_loop=0;
   int i__switch=0;
   int i__start=0;
   int i__end=0;
   int i__step=0;
   int while_end=0;
   int i_cont=0;
   int j_cont=0;
   int k_cont=0;
   double par_eta=0;
   double a1_par_eta=0;
   double par_cA0=0;
   double a1_par_cA0=0;
   double par_cB0=0;
   double a1_par_cB0=0;
   double par_cC0=0;
   double a1_par_cC0=0;
   double par_K1=0;
   double a1_par_K1=0;
   double par_K2=0;
   double a1_par_K2=0;
   double par_K3=0;
   double a1_par_K3=0;
   double par_K4=0;
   double a1_par_K4=0;
   double par_R=0;
   double a1_par_R=0;
   double var_cA=0;
   double a1_var_cA=0;
   double der_var_cA=0;
   double a1_der_var_cA=0;
   double var_cB=0;
   double a1_var_cB=0;
   double der_var_cB=0;
   double a1_der_var_cB=0;
   double var_cC=0;
   double a1_var_cC=0;
   double der_var_cC=0;
   double a1_der_var_cC=0;
   double var_r1=0;
   double a1_var_r1=0;
   double der_var_r1=0;
   double a1_der_var_r1=0;
   double var_r2=0;
   double a1_var_r2=0;
   double der_var_r2=0;
   double a1_der_var_r2=0;
   double var_y=0;
   double a1_var_y=0;
   double der_var_y=0;
   double a1_der_var_y=0;
   double var_summand=0;
   double a1_var_summand=0;
   double der_var_summand=0;
   double a1_der_var_summand=0;
   double var_summandstart=0;
   double a1_var_summandstart=0;
   double der_var_summandstart=0;
   double a1_der_var_summandstart=0;
   double var_i_expr=0;
   double a1_var_i_expr=0;
   double var_div0=0;
   double a1_var_div0=0;
   int i_i=0;
   int i_j=0;
   int i_z=0;
   double v1_0=0;
   double a1_v1_0=0;
   double v1_1=0;
   double a1_v1_1=0;
   double v1_2=0;
   double a1_v1_2=0;
   double v1_3=0;
   double a1_v1_3=0;
   double v1_4=0;
   double a1_v1_4=0;
   double v1_5=0;
   double a1_v1_5=0;
   double v1_6=0;
   double a1_v1_6=0;
   double v1_7=0;
   double a1_v1_7=0;
   double v1_8=0;
   double a1_v1_8=0;
   double v1_9=0;
   double a1_v1_9=0;
   double v1_10=0;
   double a1_v1_10=0;
   double v1_11=0;
   double a1_v1_11=0;
   double v1_12=0;
   double a1_v1_12=0;
   double v1_13=0;
   double a1_v1_13=0;
   double v1_14=0;
   double a1_v1_14=0;
   double v1_15=0;
   double a1_v1_15=0;
   double v1_16=0;
   double a1_v1_16=0;
   double v1_17=0;
   double a1_v1_17=0;
   double v1_18=0;
   double a1_v1_18=0;
   double v1_19=0;
   double a1_v1_19=0;
   double v1_20=0;
   double a1_v1_20=0;
   double v1_21=0;
   double a1_v1_21=0;
   double v1_22=0;
   double a1_v1_22=0;
   double v1_23=0;
   double a1_v1_23=0;
   double v1_24=0;
   double a1_v1_24=0;
   double v1_25=0;
   double a1_v1_25=0;
   double v1_26=0;
   double a1_v1_26=0;
   double v1_27=0;
   double a1_v1_27=0;
   double v1_28=0;
   double a1_v1_28=0;
   double v1_29=0;
   double a1_v1_29=0;
   double v1_30=0;
   double a1_v1_30=0;
   double v1_31=0;
   double a1_v1_31=0;
   int save_acs_cs_c=0;
   save_acs_cs_c=acs_cs_c;
   if (bmode_1==1) {
      // augmented forward section
      acs_cs[acs_cs_c]=0; acs_cs_c=acs_cs_c+1;
      acs_fds[acs_fds_c]=par_eta; acs_fds_c=acs_fds_c+1; par_eta=p[0];
      acs_fds[acs_fds_c]=par_cA0; acs_fds_c=acs_fds_c+1; par_cA0=p[1];
      acs_fds[acs_fds_c]=par_cB0; acs_fds_c=acs_fds_c+1; par_cB0=p[2];
      acs_fds[acs_fds_c]=par_cC0; acs_fds_c=acs_fds_c+1; par_cC0=p[3];
      acs_fds[acs_fds_c]=par_K1; acs_fds_c=acs_fds_c+1; par_K1=p[4];
      acs_fds[acs_fds_c]=par_K2; acs_fds_c=acs_fds_c+1; par_K2=p[5];
      acs_fds[acs_fds_c]=par_K3; acs_fds_c=acs_fds_c+1; par_K3=p[6];
      acs_fds[acs_fds_c]=par_K4; acs_fds_c=acs_fds_c+1; par_K4=p[7];
      acs_fds[acs_fds_c]=par_R; acs_fds_c=acs_fds_c+1; par_R=p[8];
      acs_fds[acs_fds_c]=var_cA; acs_fds_c=acs_fds_c+1; var_cA=x[0];
      acs_fds[acs_fds_c]=der_var_cA; acs_fds_c=acs_fds_c+1; der_var_cA=der_x[0];
      acs_fds[acs_fds_c]=var_cB; acs_fds_c=acs_fds_c+1; var_cB=x[1];
      acs_fds[acs_fds_c]=der_var_cB; acs_fds_c=acs_fds_c+1; der_var_cB=der_x[1];
      acs_fds[acs_fds_c]=var_cC; acs_fds_c=acs_fds_c+1; var_cC=x[2];
      acs_fds[acs_fds_c]=der_var_cC; acs_fds_c=acs_fds_c+1; der_var_cC=der_x[2];
      acs_fds[acs_fds_c]=var_r1; acs_fds_c=acs_fds_c+1; var_r1=x[3];
      acs_fds[acs_fds_c]=der_var_r1; acs_fds_c=acs_fds_c+1; der_var_r1=der_x[3];
      acs_fds[acs_fds_c]=var_r2; acs_fds_c=acs_fds_c+1; var_r2=x[4];
      acs_fds[acs_fds_c]=der_var_r2; acs_fds_c=acs_fds_c+1; der_var_r2=der_x[4];
      acs_fds[acs_fds_c]=var_y; acs_fds_c=acs_fds_c+1; var_y=x[5];
      acs_fds[acs_fds_c]=der_var_y; acs_fds_c=acs_fds_c+1; der_var_y=der_x[5];
      acs_fds[acs_fds_c]=var_summand; acs_fds_c=acs_fds_c+1; var_summand=x[6];
      acs_fds[acs_fds_c]=der_var_summand; acs_fds_c=acs_fds_c+1; der_var_summand=der_x[6];
      acs_fds[acs_fds_c]=var_summandstart; acs_fds_c=acs_fds_c+1; var_summandstart=x[7];
      acs_fds[acs_fds_c]=der_var_summandstart; acs_fds_c=acs_fds_c+1; der_var_summandstart=der_x[7];
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_cA-(0-var_r1);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_cB-(var_r1-2*var_r2);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_cC-(var_r1+var_r2);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_r1-(par_K1*var_cA-par_K2*var_cB*var_cC);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_r2-(par_K3*var_cB*var_cB-par_K4*var_cC);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_y-(32.84*(var_cA+var_cB+var_cC));
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr; acs_fds_c=acs_fds_c+1; var_i_expr=(var_y-par_eta);
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_i_expr,a1_var_i_expr,par_R,a1_par_R,var_div0,a1_var_div0);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_summand-((var_y-par_eta)*var_div0);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_summandstart-((var_cA-par_cA0)*(var_cA-par_cA0)+(var_cB-par_cB0)*(var_cB-par_cB0)+(var_cC-par_cC0)*(var_cC-par_cC0));
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_ids[acs_ids_c]=n_c; acs_ids_c=acs_ids_c+1; n_c=i_C;
      // For the case you need the actual function value at the end of the forward section, use this mode for storing it.
      // reverse section
      while (acs_cs_c>save_acs_cs_c) {
            acs_cs_c=acs_cs_c-1;
            if (acs_cs[acs_cs_c]==0) {
              acs_ids_c=acs_ids_c-1; n_c=acs_ids[acs_ids_c];
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_summandstart;
              v1_1=var_cA;
              v1_2=par_cA0;
              v1_3=v1_1-v1_2;
              v1_4=v1_3;
              v1_5=var_cA;
              v1_6=par_cA0;
              v1_7=v1_5-v1_6;
              v1_8=v1_7;
              v1_9=v1_4*v1_8;
              v1_10=var_cB;
              v1_11=par_cB0;
              v1_12=v1_10-v1_11;
              v1_13=v1_12;
              v1_14=var_cB;
              v1_15=par_cB0;
              v1_16=v1_14-v1_15;
              v1_17=v1_16;
              v1_18=v1_13*v1_17;
              v1_19=v1_9+v1_18;
              v1_20=var_cC;
              v1_21=par_cC0;
              v1_22=v1_20-v1_21;
              v1_23=v1_22;
              v1_24=var_cC;
              v1_25=par_cC0;
              v1_26=v1_24-v1_25;
              v1_27=v1_26;
              v1_28=v1_23*v1_27;
              v1_29=v1_19+v1_28;
              v1_30=v1_29;
              v1_31=v1_0-v1_30;
              a1_v1_31=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_31; a1_v1_30=0-a1_v1_31;
              a1_v1_29=a1_v1_30;
              a1_v1_19=a1_v1_29; a1_v1_28=a1_v1_29;
              a1_v1_23=v1_27*a1_v1_28; a1_v1_27=v1_23*a1_v1_28;
              a1_v1_26=a1_v1_27;
              a1_v1_24=a1_v1_26; a1_v1_25=0-a1_v1_26;
              a1_par_cC0=a1_par_cC0+a1_v1_25;
              a1_var_cC=a1_var_cC+a1_v1_24;
              a1_v1_22=a1_v1_23;
              a1_v1_20=a1_v1_22; a1_v1_21=0-a1_v1_22;
              a1_par_cC0=a1_par_cC0+a1_v1_21;
              a1_var_cC=a1_var_cC+a1_v1_20;
              a1_v1_9=a1_v1_19; a1_v1_18=a1_v1_19;
              a1_v1_13=v1_17*a1_v1_18; a1_v1_17=v1_13*a1_v1_18;
              a1_v1_16=a1_v1_17;
              a1_v1_14=a1_v1_16; a1_v1_15=0-a1_v1_16;
              a1_par_cB0=a1_par_cB0+a1_v1_15;
              a1_var_cB=a1_var_cB+a1_v1_14;
              a1_v1_12=a1_v1_13;
              a1_v1_10=a1_v1_12; a1_v1_11=0-a1_v1_12;
              a1_par_cB0=a1_par_cB0+a1_v1_11;
              a1_var_cB=a1_var_cB+a1_v1_10;
              a1_v1_4=v1_8*a1_v1_9; a1_v1_8=v1_4*a1_v1_9;
              a1_v1_7=a1_v1_8;
              a1_v1_5=a1_v1_7; a1_v1_6=0-a1_v1_7;
              a1_par_cA0=a1_par_cA0+a1_v1_6;
              a1_var_cA=a1_var_cA+a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_par_cA0=a1_par_cA0+a1_v1_2;
              a1_var_cA=a1_var_cA+a1_v1_1;
              a1_var_summandstart=a1_var_summandstart+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_summand;
              v1_1=var_y;
              v1_2=par_eta;
              v1_3=v1_1-v1_2;
              v1_4=v1_3;
              v1_5=var_div0;
              v1_6=v1_4*v1_5;
              v1_7=v1_6;
              v1_8=v1_0-v1_7;
              a1_v1_8=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_8; a1_v1_7=0-a1_v1_8;
              a1_v1_6=a1_v1_7;
              a1_v1_4=v1_5*a1_v1_6; a1_v1_5=v1_4*a1_v1_6;
              a1_var_div0=a1_var_div0+a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_par_eta=a1_par_eta+a1_v1_2;
              a1_var_y=a1_var_y+a1_v1_1;
              a1_var_summand=a1_var_summand+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_i_expr,a1_var_i_expr,par_R,a1_par_R,var_div0,a1_var_div0);
              acs_fds_c=acs_fds_c-1; var_i_expr=acs_fds[acs_fds_c];
              v1_0=var_y;
              v1_1=par_eta;
              v1_2=v1_0-v1_1;
              v1_3=v1_2;
              a1_v1_3=a1_var_i_expr; a1_var_i_expr=0;
              a1_v1_2=a1_v1_3;
              a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
              a1_par_eta=a1_par_eta+a1_v1_1;
              a1_var_y=a1_var_y+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_y;
              v1_1=32.84;
              v1_2=var_cA;
              v1_3=var_cB;
              v1_4=v1_2+v1_3;
              v1_5=var_cC;
              v1_6=v1_4+v1_5;
              v1_7=v1_6;
              v1_8=v1_1*v1_7;
              v1_9=v1_8;
              v1_10=v1_0-v1_9;
              a1_v1_10=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_10; a1_v1_9=0-a1_v1_10;
              a1_v1_8=a1_v1_9;
              a1_v1_1=v1_7*a1_v1_8; a1_v1_7=v1_1*a1_v1_8;
              a1_v1_6=a1_v1_7;
              a1_v1_4=a1_v1_6; a1_v1_5=a1_v1_6;
              a1_var_cC=a1_var_cC+a1_v1_5;
              a1_v1_2=a1_v1_4; a1_v1_3=a1_v1_4;
              a1_var_cB=a1_var_cB+a1_v1_3;
              a1_var_cA=a1_var_cA+a1_v1_2;
              a1_var_y=a1_var_y+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_r2;
              v1_1=par_K3;
              v1_2=var_cB;
              v1_3=v1_1*v1_2;
              v1_4=var_cB;
              v1_5=v1_3*v1_4;
              v1_6=par_K4;
              v1_7=var_cC;
              v1_8=v1_6*v1_7;
              v1_9=v1_5-v1_8;
              v1_10=v1_9;
              v1_11=v1_0-v1_10;
              a1_v1_11=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_11; a1_v1_10=0-a1_v1_11;
              a1_v1_9=a1_v1_10;
              a1_v1_5=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_6=v1_7*a1_v1_8; a1_v1_7=v1_6*a1_v1_8;
              a1_var_cC=a1_var_cC+a1_v1_7;
              a1_par_K4=a1_par_K4+a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_cB=a1_var_cB+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_cB=a1_var_cB+a1_v1_2;
              a1_par_K3=a1_par_K3+a1_v1_1;
              a1_var_r2=a1_var_r2+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_r1;
              v1_1=par_K1;
              v1_2=var_cA;
              v1_3=v1_1*v1_2;
              v1_4=par_K2;
              v1_5=var_cB;
              v1_6=v1_4*v1_5;
              v1_7=var_cC;
              v1_8=v1_6*v1_7;
              v1_9=v1_3-v1_8;
              v1_10=v1_9;
              v1_11=v1_0-v1_10;
              a1_v1_11=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_11; a1_v1_10=0-a1_v1_11;
              a1_v1_9=a1_v1_10;
              a1_v1_3=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_6=v1_7*a1_v1_8; a1_v1_7=v1_6*a1_v1_8;
              a1_var_cC=a1_var_cC+a1_v1_7;
              a1_v1_4=v1_5*a1_v1_6; a1_v1_5=v1_4*a1_v1_6;
              a1_var_cB=a1_var_cB+a1_v1_5;
              a1_par_K2=a1_par_K2+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_cA=a1_var_cA+a1_v1_2;
              a1_par_K1=a1_par_K1+a1_v1_1;
              a1_var_r1=a1_var_r1+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_cC;
              v1_1=var_r1;
              v1_2=var_r2;
              v1_3=v1_1+v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=a1_v1_3;
              a1_var_r2=a1_var_r2+a1_v1_2;
              a1_var_r1=a1_var_r1+a1_v1_1;
              a1_der_var_cC=a1_der_var_cC+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_cB;
              v1_1=var_r1;
              v1_2=2;
              v1_3=var_r2;
              v1_4=v1_2*v1_3;
              v1_5=v1_1-v1_4;
              v1_6=v1_5;
              v1_7=v1_0-v1_6;
              a1_v1_7=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_7; a1_v1_6=0-a1_v1_7;
              a1_v1_5=a1_v1_6;
              a1_v1_1=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_2=v1_3*a1_v1_4; a1_v1_3=v1_2*a1_v1_4;
              a1_var_r2=a1_var_r2+a1_v1_3;
              a1_var_r1=a1_var_r1+a1_v1_1;
              a1_der_var_cB=a1_der_var_cB+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_cA;
              v1_1=var_r1;
              v1_2=-v1_1;
              v1_3=v1_2;
              v1_4=v1_0-v1_3;
              a1_v1_4=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_4; a1_v1_3=0-a1_v1_4;
              a1_v1_2=a1_v1_3;
              a1_v1_1=-a1_v1_2;
              a1_var_r1=a1_var_r1+a1_v1_1;
              a1_der_var_cA=a1_der_var_cA+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_summandstart=acs_fds[acs_fds_c];
              v1_0=der_x[7];
              a1_v1_0=a1_der_var_summandstart; a1_der_var_summandstart=0;
              a1_der_x[7]=a1_der_x[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_summandstart=acs_fds[acs_fds_c];
              v1_0=x[7];
              a1_v1_0=a1_var_summandstart; a1_var_summandstart=0;
              a1_x[7]=a1_x[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_summand=acs_fds[acs_fds_c];
              v1_0=der_x[6];
              a1_v1_0=a1_der_var_summand; a1_der_var_summand=0;
              a1_der_x[6]=a1_der_x[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_summand=acs_fds[acs_fds_c];
              v1_0=x[6];
              a1_v1_0=a1_var_summand; a1_var_summand=0;
              a1_x[6]=a1_x[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_y=acs_fds[acs_fds_c];
              v1_0=der_x[5];
              a1_v1_0=a1_der_var_y; a1_der_var_y=0;
              a1_der_x[5]=a1_der_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_y=acs_fds[acs_fds_c];
              v1_0=x[5];
              a1_v1_0=a1_var_y; a1_var_y=0;
              a1_x[5]=a1_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_r2=acs_fds[acs_fds_c];
              v1_0=der_x[4];
              a1_v1_0=a1_der_var_r2; a1_der_var_r2=0;
              a1_der_x[4]=a1_der_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_r2=acs_fds[acs_fds_c];
              v1_0=x[4];
              a1_v1_0=a1_var_r2; a1_var_r2=0;
              a1_x[4]=a1_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_r1=acs_fds[acs_fds_c];
              v1_0=der_x[3];
              a1_v1_0=a1_der_var_r1; a1_der_var_r1=0;
              a1_der_x[3]=a1_der_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_r1=acs_fds[acs_fds_c];
              v1_0=x[3];
              a1_v1_0=a1_var_r1; a1_var_r1=0;
              a1_x[3]=a1_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_cC=acs_fds[acs_fds_c];
              v1_0=der_x[2];
              a1_v1_0=a1_der_var_cC; a1_der_var_cC=0;
              a1_der_x[2]=a1_der_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_cC=acs_fds[acs_fds_c];
              v1_0=x[2];
              a1_v1_0=a1_var_cC; a1_var_cC=0;
              a1_x[2]=a1_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_cB=acs_fds[acs_fds_c];
              v1_0=der_x[1];
              a1_v1_0=a1_der_var_cB; a1_der_var_cB=0;
              a1_der_x[1]=a1_der_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_cB=acs_fds[acs_fds_c];
              v1_0=x[1];
              a1_v1_0=a1_var_cB; a1_var_cB=0;
              a1_x[1]=a1_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_cA=acs_fds[acs_fds_c];
              v1_0=der_x[0];
              a1_v1_0=a1_der_var_cA; a1_der_var_cA=0;
              a1_der_x[0]=a1_der_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_cA=acs_fds[acs_fds_c];
              v1_0=x[0];
              a1_v1_0=a1_var_cA; a1_var_cA=0;
              a1_x[0]=a1_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_R=acs_fds[acs_fds_c];
              v1_0=p[8];
              a1_v1_0=a1_par_R; a1_par_R=0;
              a1_p[8]=a1_p[8]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_K4=acs_fds[acs_fds_c];
              v1_0=p[7];
              a1_v1_0=a1_par_K4; a1_par_K4=0;
              a1_p[7]=a1_p[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_K3=acs_fds[acs_fds_c];
              v1_0=p[6];
              a1_v1_0=a1_par_K3; a1_par_K3=0;
              a1_p[6]=a1_p[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_K2=acs_fds[acs_fds_c];
              v1_0=p[5];
              a1_v1_0=a1_par_K2; a1_par_K2=0;
              a1_p[5]=a1_p[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_K1=acs_fds[acs_fds_c];
              v1_0=p[4];
              a1_v1_0=a1_par_K1; a1_par_K1=0;
              a1_p[4]=a1_p[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_cC0=acs_fds[acs_fds_c];
              v1_0=p[3];
              a1_v1_0=a1_par_cC0; a1_par_cC0=0;
              a1_p[3]=a1_p[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_cB0=acs_fds[acs_fds_c];
              v1_0=p[2];
              a1_v1_0=a1_par_cB0; a1_par_cB0=0;
              a1_p[2]=a1_p[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_cA0=acs_fds[acs_fds_c];
              v1_0=p[1];
              a1_v1_0=a1_par_cA0; a1_par_cA0=0;
              a1_p[1]=a1_p[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_eta=acs_fds[acs_fds_c];
              v1_0=p[0];
              a1_v1_0=a1_par_eta; a1_par_eta=0;
              a1_p[0]=a1_p[0]+a1_v1_0;
            }
          }
       }
       if (bmode_1==2) {
          res(yy, der_x, x, p, condit, lock, prev, n_x, n_p, n_c);
       }
}
